subversion.py
933 lines
| 35.4 KiB
| text/x-python
|
PythonLexer
Daniel Holth
|
r4765 | # Subversion 1.4/1.5 Python API backend | ||
# | ||||
# Copyright(C) 2007 Daniel Holth et al | ||||
Bryan O'Sullivan
|
r4925 | # | ||
# Configuration options: | ||||
# | ||||
# convert.svn.trunk | ||||
# Relative path to the trunk (default: "trunk") | ||||
# convert.svn.branches | ||||
# Relative path to tree of branches (default: "branches") | ||||
Kirill Smelkov
|
r5462 | # convert.svn.tags | ||
# Relative path to tree of tags (default: "tags") | ||||
Bryan O'Sullivan
|
r4925 | # | ||
# Set these in a hgrc, or on the command line as follows: | ||||
# | ||||
# hg convert --config convert.svn.trunk=wackoname [...] | ||||
Daniel Holth
|
r4765 | |||
import locale | ||||
Bryan O'Sullivan
|
r4946 | import os | ||
Bryan O'Sullivan
|
r5513 | import re | ||
Thomas Arendsen Hein
|
r5139 | import sys | ||
Bryan O'Sullivan
|
r4946 | import cPickle as pickle | ||
Bryan O'Sullivan
|
r5513 | import tempfile | ||
from mercurial import strutil, util | ||||
from mercurial.i18n import _ | ||||
Daniel Holth
|
r4765 | |||
# Subversion stuff. Works best with very recent Python SVN bindings | ||||
# e.g. SVN 1.5 or backports. Thanks to the bzr folks for enhancing | ||||
# these bindings. | ||||
from cStringIO import StringIO | ||||
Thomas Arendsen Hein
|
r5139 | from common import NoRepo, commit, converter_source, encodeargs, decodeargs | ||
Bryan O'Sullivan
|
r5513 | from common import commandline, converter_sink, mapfile | ||
Brendan Cully
|
r4766 | |||
try: | ||||
from svn.core import SubversionException, Pool | ||||
Brendan Cully
|
r5010 | import svn | ||
import svn.client | ||||
Brendan Cully
|
r4766 | import svn.core | ||
import svn.ra | ||||
import svn.delta | ||||
import transport | ||||
except ImportError: | ||||
pass | ||||
Daniel Holth
|
r4765 | |||
Brendan Cully
|
r5008 | def geturl(path): | ||
Brendan Cully
|
r5010 | try: | ||
Brendan Cully
|
r5020 | return svn.client.url_from_path(svn.core.svn_path_canonicalize(path)) | ||
Brendan Cully
|
r5010 | except SubversionException: | ||
pass | ||||
Brendan Cully
|
r5008 | if os.path.isdir(path): | ||
Shun-ichi GOTO
|
r5793 | path = os.path.normpath(os.path.abspath(path)) | ||
if os.name == 'nt': | ||||
Shun-ichi GOTO
|
r5842 | path = '/' + util.normpath(path) | ||
Shun-ichi GOTO
|
r5793 | return 'file://%s' % path | ||
Brendan Cully
|
r5008 | return path | ||
Brendan Cully
|
r5117 | def optrev(number): | ||
optrev = svn.core.svn_opt_revision_t() | ||||
optrev.kind = svn.core.svn_opt_revision_number | ||||
optrev.value.number = number | ||||
return optrev | ||||
Bryan O'Sullivan
|
r4946 | class changedpath(object): | ||
def __init__(self, p): | ||||
self.copyfrom_path = p.copyfrom_path | ||||
self.copyfrom_rev = p.copyfrom_rev | ||||
self.action = p.action | ||||
Patrick Mezard
|
r5127 | def get_log_child(fp, url, paths, start, end, limit=0, discover_changed_paths=True, | ||
strict_node_history=False): | ||||
protocol = -1 | ||||
def receiver(orig_paths, revnum, author, date, message, pool): | ||||
if orig_paths is not None: | ||||
for k, v in orig_paths.iteritems(): | ||||
orig_paths[k] = changedpath(v) | ||||
pickle.dump((orig_paths, revnum, author, date, message), | ||||
Thomas Arendsen Hein
|
r5143 | fp, protocol) | ||
Patrick Mezard
|
r5127 | try: | ||
# Use an ra of our own so that our parent can consume | ||||
# our results without confusing the server. | ||||
t = transport.SvnRaTransport(url=url) | ||||
svn.ra.get_log(t.ra, paths, start, end, limit, | ||||
discover_changed_paths, | ||||
strict_node_history, | ||||
receiver) | ||||
Thomas Arendsen Hein
|
r5140 | except SubversionException, (inst, num): | ||
Patrick Mezard
|
r5127 | pickle.dump(num, fp, protocol) | ||
else: | ||||
pickle.dump(None, fp, protocol) | ||||
fp.close() | ||||
Thomas Arendsen Hein
|
r5139 | def debugsvnlog(ui, **opts): | ||
"""Fetch SVN log in a subprocess and channel them back to parent to | ||||
avoid memory collection issues. | ||||
""" | ||||
util.set_binary(sys.stdin) | ||||
util.set_binary(sys.stdout) | ||||
args = decodeargs(sys.stdin.read()) | ||||
get_log_child(sys.stdout, *args) | ||||
Daniel Holth
|
r4765 | # SVN conversion code stolen from bzr-svn and tailor | ||
Bryan O'Sullivan
|
r5438 | class svn_source(converter_source): | ||
Brendan Cully
|
r4766 | def __init__(self, ui, url, rev=None): | ||
Bryan O'Sullivan
|
r5438 | super(svn_source, self).__init__(ui, url, rev=rev) | ||
Brendan Cully
|
r4807 | |||
Brendan Cully
|
r4766 | try: | ||
SubversionException | ||||
except NameError: | ||||
Alexis S. L. Carvalho
|
r5521 | raise NoRepo('Subversion python bindings could not be loaded') | ||
Brendan Cully
|
r4766 | |||
Daniel Holth
|
r4765 | self.encoding = locale.getpreferredencoding() | ||
Brendan Cully
|
r4813 | self.lastrevs = {} | ||
Brendan Cully
|
r4766 | latest = None | ||
Daniel Holth
|
r4765 | try: | ||
# Support file://path@rev syntax. Useful e.g. to convert | ||||
# deleted branches. | ||||
Bryan O'Sullivan
|
r4927 | at = url.rfind('@') | ||
if at >= 0: | ||||
latest = int(url[at+1:]) | ||||
url = url[:at] | ||||
Daniel Holth
|
r4765 | except ValueError, e: | ||
Brendan Cully
|
r4766 | pass | ||
Brendan Cully
|
r5008 | self.url = geturl(url) | ||
Daniel Holth
|
r4765 | self.encoding = 'UTF-8' # Subversion is always nominal UTF-8 | ||
try: | ||||
Brendan Cully
|
r5008 | self.transport = transport.SvnRaTransport(url=self.url) | ||
Daniel Holth
|
r4765 | self.ra = self.transport.ra | ||
Bryan O'Sullivan
|
r4946 | self.ctx = self.transport.client | ||
Daniel Holth
|
r4765 | self.base = svn.ra.get_repos_root(self.ra) | ||
self.module = self.url[len(self.base):] | ||||
self.modulemap = {} # revision, module | ||||
self.commits = {} | ||||
Brendan Cully
|
r5121 | self.paths = {} | ||
Daniel Holth
|
r4765 | self.uuid = svn.ra.get_uuid(self.ra).decode(self.encoding) | ||
except SubversionException, e: | ||||
Bryan O'Sullivan
|
r5437 | ui.print_exc() | ||
Alexis S. L. Carvalho
|
r5521 | raise NoRepo("%s does not look like a Subversion repo" % self.url) | ||
Daniel Holth
|
r4765 | |||
Thomas Arendsen Hein
|
r5145 | if rev: | ||
try: | ||||
latest = int(rev) | ||||
except ValueError: | ||||
raise util.Abort('svn: revision %s is not an integer' % rev) | ||||
Daniel Holth
|
r4765 | try: | ||
self.get_blacklist() | ||||
except IOError, e: | ||||
pass | ||||
Brendan Cully
|
r4789 | self.last_changed = self.latest(self.module, latest) | ||
Daniel Holth
|
r4765 | |||
Brendan Cully
|
r4810 | self.head = self.revid(self.last_changed) | ||
Alexis S. L. Carvalho
|
r5382 | self._changescache = None | ||
Daniel Holth
|
r4765 | |||
Bryan O'Sullivan
|
r5554 | if os.path.exists(os.path.join(url, '.svn/entries')): | ||
self.wc = url | ||||
else: | ||||
self.wc = None | ||||
self.convertfp = None | ||||
Bryan O'Sullivan
|
r5510 | def setrevmap(self, revmap): | ||
Brendan Cully
|
r4840 | lastrevs = {} | ||
Bryan O'Sullivan
|
r5511 | for revid in revmap.iterkeys(): | ||
Brendan Cully
|
r4840 | uuid, module, revnum = self.revsplit(revid) | ||
lastrevnum = lastrevs.setdefault(module, revnum) | ||||
if revnum > lastrevnum: | ||||
lastrevs[module] = revnum | ||||
self.lastrevs = lastrevs | ||||
Bryan O'Sullivan
|
r4925 | def exists(self, path, optrev): | ||
try: | ||||
Kirill Smelkov
|
r5461 | svn.client.ls(self.url.rstrip('/') + '/' + path, | ||
Bryan O'Sullivan
|
r4925 | optrev, False, self.ctx) | ||
Kirill Smelkov
|
r5461 | return True | ||
Bryan O'Sullivan
|
r4925 | except SubversionException, err: | ||
Kirill Smelkov
|
r5461 | return False | ||
Bryan O'Sullivan
|
r4925 | |||
Brendan Cully
|
r4840 | def getheads(self): | ||
Edouard Gomez
|
r5854 | |||
def getcfgpath(name, rev): | ||||
cfgpath = self.ui.config('convert', 'svn.' + name) | ||||
path = (cfgpath or name).strip('/') | ||||
if not self.exists(path, rev): | ||||
if cfgpath: | ||||
raise util.Abort(_('expected %s to be at %r, but not found') | ||||
% (name, path)) | ||||
return None | ||||
self.ui.note(_('found %s at %r\n') % (name, path)) | ||||
return path | ||||
Brendan Cully
|
r5117 | rev = optrev(self.last_changed) | ||
Edouard Gomez
|
r5854 | oldmodule = '' | ||
trunk = getcfgpath('trunk', rev) | ||||
tags = getcfgpath('tags', rev) | ||||
branches = getcfgpath('branches', rev) | ||||
# If the project has a trunk or branches, we will extract heads | ||||
# from them. We keep the project root otherwise. | ||||
if trunk: | ||||
oldmodule = self.module or '' | ||||
Bryan O'Sullivan
|
r4925 | self.module += '/' + trunk | ||
Brendan Cully
|
r4840 | lt = self.latest(self.module, self.last_changed) | ||
self.head = self.revid(lt) | ||||
Edouard Gomez
|
r5854 | |||
# First head in the list is the module's head | ||||
self.heads = [self.head] | ||||
self.tags = '%s/%s' % (oldmodule , (tags or 'tags')) | ||||
# Check if branches bring a few more heads to the list | ||||
if branches: | ||||
rpath = self.url.strip('/') | ||||
Brendan Cully
|
r5117 | branchnames = svn.client.ls(rpath + '/' + branches, rev, False, | ||
Bryan O'Sullivan
|
r4925 | self.ctx) | ||
for branch in branchnames.keys(): | ||||
Edouard Gomez
|
r5854 | module = '%s/%s/%s' % (oldmodule, branches, branch) | ||
Brendan Cully
|
r4840 | brevnum = self.latest(module, self.last_changed) | ||
brev = self.revid(brevnum, module) | ||||
self.ui.note('found branch %s at %d\n' % (branch, brevnum)) | ||||
self.heads.append(brev) | ||||
Kirill Smelkov
|
r5462 | |||
Brendan Cully
|
r4840 | return self.heads | ||
def getfile(self, file, rev): | ||||
data, mode = self._getfile(file, rev) | ||||
self.modecache[(file, rev)] = mode | ||||
return data | ||||
Thomas Arendsen Hein
|
r4957 | def getmode(self, file, rev): | ||
Brendan Cully
|
r4840 | return self.modecache[(file, rev)] | ||
def getchanges(self, rev): | ||||
Alexis S. L. Carvalho
|
r5382 | if self._changescache and self._changescache[0] == rev: | ||
return self._changescache[1] | ||||
self._changescache = None | ||||
Brendan Cully
|
r4840 | self.modecache = {} | ||
Brendan Cully
|
r5121 | (paths, parents) = self.paths[rev] | ||
files, copies = self.expandpaths(rev, paths, parents) | ||||
files.sort() | ||||
files = zip(files, [rev] * len(files)) | ||||
Brendan Cully
|
r4840 | # caller caches the result, so free it here to release memory | ||
Brendan Cully
|
r5121 | del self.paths[rev] | ||
return (files, copies) | ||||
Brendan Cully
|
r4840 | |||
Alexis S. L. Carvalho
|
r5382 | def getchangedfiles(self, rev, i): | ||
changes = self.getchanges(rev) | ||||
self._changescache = (rev, changes) | ||||
return [f[0] for f in changes[0]] | ||||
Brendan Cully
|
r4840 | def getcommit(self, rev): | ||
if rev not in self.commits: | ||||
uuid, module, revnum = self.revsplit(rev) | ||||
self.module = module | ||||
self.reparent(module) | ||||
stop = self.lastrevs.get(module, 0) | ||||
self._fetch_revisions(from_revnum=revnum, to_revnum=stop) | ||||
commit = self.commits[rev] | ||||
# caller caches the result, so free it here to release memory | ||||
del self.commits[rev] | ||||
return commit | ||||
Bryan O'Sullivan
|
r4946 | def get_log(self, paths, start, end, limit=0, discover_changed_paths=True, | ||
strict_node_history=False): | ||||
def parent(fp): | ||||
while True: | ||||
entry = pickle.load(fp) | ||||
try: | ||||
orig_paths, revnum, author, date, message = entry | ||||
except: | ||||
if entry is None: | ||||
break | ||||
raise SubversionException("child raised exception", entry) | ||||
yield entry | ||||
Thomas Arendsen Hein
|
r5143 | |||
Patrick Mezard
|
r5127 | args = [self.url, paths, start, end, limit, discover_changed_paths, | ||
strict_node_history] | ||||
arg = encodeargs(args) | ||||
hgexe = util.hgexecutable() | ||||
Thomas Arendsen Hein
|
r5144 | cmd = '%s debugsvnlog' % util.shellquote(hgexe) | ||
Patrick Mezard
|
r5127 | stdin, stdout = os.popen2(cmd, 'b') | ||
Thomas Arendsen Hein
|
r5143 | |||
Patrick Mezard
|
r5127 | stdin.write(arg) | ||
stdin.close() | ||||
Bryan O'Sullivan
|
r4946 | |||
Patrick Mezard
|
r5127 | for p in parent(stdout): | ||
yield p | ||||
Bryan O'Sullivan
|
r4946 | |||
Brendan Cully
|
r4840 | def gettags(self): | ||
tags = {} | ||||
Bryan O'Sullivan
|
r4949 | start = self.revnum(self.head) | ||
try: | ||||
Kirill Smelkov
|
r5462 | for entry in self.get_log([self.tags], 0, start): | ||
Bryan O'Sullivan
|
r4949 | orig_paths, revnum, author, date, message = entry | ||
for path in orig_paths: | ||||
Kirill Smelkov
|
r5462 | if not path.startswith(self.tags+'/'): | ||
Bryan O'Sullivan
|
r4949 | continue | ||
ent = orig_paths[path] | ||||
source = ent.copyfrom_path | ||||
rev = ent.copyfrom_rev | ||||
Kirill Smelkov
|
r5462 | tag = path.split('/')[-1] | ||
Bryan O'Sullivan
|
r4949 | tags[tag] = self.revid(rev, module=source) | ||
Thomas Arendsen Hein
|
r5140 | except SubversionException, (inst, num): | ||
Bryan O'Sullivan
|
r4949 | self.ui.note('no tags found at revision %d\n' % start) | ||
Bryan O'Sullivan
|
r4946 | return tags | ||
Brendan Cully
|
r4840 | |||
Bryan O'Sullivan
|
r5554 | def converted(self, rev, destrev): | ||
if not self.wc: | ||||
return | ||||
if self.convertfp is None: | ||||
self.convertfp = open(os.path.join(self.wc, '.svn', 'hg-shamap'), | ||||
'a') | ||||
self.convertfp.write('%s %d\n' % (destrev, self.revnum(rev))) | ||||
self.convertfp.flush() | ||||
Brendan Cully
|
r4840 | # -- helper functions -- | ||
Brendan Cully
|
r4810 | def revid(self, revnum, module=None): | ||
Brendan Cully
|
r4795 | if not module: | ||
module = self.module | ||||
Thomas Arendsen Hein
|
r5287 | return u"svn:%s%s@%s" % (self.uuid, module.decode(self.encoding), | ||
revnum) | ||||
Brendan Cully
|
r4774 | |||
def revnum(self, rev): | ||||
return int(rev.split('@')[-1]) | ||||
Brendan Cully
|
r4789 | |||
Brendan Cully
|
r4794 | def revsplit(self, rev): | ||
url, revnum = rev.encode(self.encoding).split('@', 1) | ||||
revnum = int(revnum) | ||||
parts = url.split('/', 1) | ||||
uuid = parts.pop(0)[4:] | ||||
Brendan Cully
|
r4797 | mod = '' | ||
Brendan Cully
|
r4794 | if parts: | ||
Brendan Cully
|
r4797 | mod = '/' + parts[0] | ||
Brendan Cully
|
r4794 | return uuid, mod, revnum | ||
Brendan Cully
|
r4790 | def latest(self, path, stop=0): | ||
Brendan Cully
|
r4789 | 'find the latest revision affecting path, up to stop' | ||
if not stop: | ||||
stop = svn.ra.get_latest_revnum(self.ra) | ||||
try: | ||||
self.reparent('') | ||||
dirent = svn.ra.stat(self.ra, path.strip('/'), stop) | ||||
self.reparent(self.module) | ||||
except SubversionException: | ||||
dirent = None | ||||
if not dirent: | ||||
Bryan O'Sullivan
|
r4925 | raise util.Abort('%s not found up to revision %d' % (path, stop)) | ||
Brendan Cully
|
r4789 | |||
return dirent.created_rev | ||||
Daniel Holth
|
r4765 | def get_blacklist(self): | ||
"""Avoid certain revision numbers. | ||||
It is not uncommon for two nearby revisions to cancel each other | ||||
out, e.g. 'I copied trunk into a subdirectory of itself instead | ||||
of making a branch'. The converted repository is significantly | ||||
smaller if we ignore such revisions.""" | ||||
Thomas Arendsen Hein
|
r5276 | self.blacklist = util.set() | ||
Daniel Holth
|
r4765 | blacklist = self.blacklist | ||
for line in file("blacklist.txt", "r"): | ||||
if not line.startswith("#"): | ||||
try: | ||||
svn_rev = int(line.strip()) | ||||
blacklist.add(svn_rev) | ||||
except ValueError, e: | ||||
pass # not an integer or a comment | ||||
def is_blacklisted(self, svn_rev): | ||||
return svn_rev in self.blacklist | ||||
def reparent(self, module): | ||||
svn_url = self.base + module | ||||
self.ui.debug("reparent to %s\n" % svn_url.encode(self.encoding)) | ||||
svn.ra.reparent(self.ra, svn_url.encode(self.encoding)) | ||||
Brendan Cully
|
r5120 | def expandpaths(self, rev, paths, parents): | ||
Daniel Holth
|
r4765 | def get_entry_from_path(path, module=self.module): | ||
# Given the repository url of this wc, say | ||||
# "http://server/plone/CMFPlone/branches/Plone-2_0-branch" | ||||
# extract the "entry" portion (a relative path) from what | ||||
# svn log --xml says, ie | ||||
# "/CMFPlone/branches/Plone-2_0-branch/tests/PloneTestCase.py" | ||||
# that is to say "tests/PloneTestCase.py" | ||||
if path.startswith(module): | ||||
relative = path[len(module):] | ||||
if relative.startswith('/'): | ||||
return relative[1:] | ||||
else: | ||||
return relative | ||||
# The path is outside our tracked tree... | ||||
Brendan Cully
|
r5120 | self.ui.debug('%r is not under %r, ignoring\n' % (path, module)) | ||
Daniel Holth
|
r4765 | return None | ||
Brendan Cully
|
r5120 | entries = [] | ||
copyfrom = {} # Map of entrypath, revision for finding source of deleted revisions. | ||||
copies = {} | ||||
revnum = self.revnum(rev) | ||||
Brendan Cully
|
r5121 | if revnum in self.modulemap: | ||
new_module = self.modulemap[revnum] | ||||
if new_module != self.module: | ||||
self.module = new_module | ||||
self.reparent(self.module) | ||||
Brendan Cully
|
r5120 | for path, ent in paths: | ||
entrypath = get_entry_from_path(path, module=self.module) | ||||
entry = entrypath.decode(self.encoding) | ||||
kind = svn.ra.check_path(self.ra, entrypath, revnum) | ||||
if kind == svn.core.svn_node_file: | ||||
if ent.copyfrom_path: | ||||
copyfrom_path = get_entry_from_path(ent.copyfrom_path) | ||||
if copyfrom_path: | ||||
"Shun-ichi GOTO"
|
r5841 | self.ui.debug("Copied to %s from %s@%s\n" % | ||
(entrypath, copyfrom_path, | ||||
ent.copyfrom_rev)) | ||||
Brendan Cully
|
r5120 | # It's probably important for hg that the source | ||
# exists in the revision's parent, not just the | ||||
# ent.copyfrom_rev | ||||
fromkind = svn.ra.check_path(self.ra, copyfrom_path, ent.copyfrom_rev) | ||||
if fromkind != 0: | ||||
copies[self.recode(entry)] = self.recode(copyfrom_path) | ||||
entries.append(self.recode(entry)) | ||||
elif kind == 0: # gone, but had better be a deleted *file* | ||||
self.ui.debug("gone from %s\n" % ent.copyfrom_rev) | ||||
# if a branch is created but entries are removed in the same | ||||
# changeset, get the right fromrev | ||||
if parents: | ||||
uuid, old_module, fromrev = self.revsplit(parents[0]) | ||||
else: | ||||
fromrev = revnum - 1 | ||||
# might always need to be revnum - 1 in these 3 lines? | ||||
old_module = self.modulemap.get(fromrev, self.module) | ||||
basepath = old_module + "/" + get_entry_from_path(path, module=self.module) | ||||
entrypath = old_module + "/" + get_entry_from_path(path, module=self.module) | ||||
def lookup_parts(p): | ||||
rc = None | ||||
parts = p.split("/") | ||||
for i in range(len(parts)): | ||||
part = "/".join(parts[:i]) | ||||
info = part, copyfrom.get(part, None) | ||||
if info[1] is not None: | ||||
self.ui.debug("Found parent directory %s\n" % info[1]) | ||||
rc = info | ||||
return rc | ||||
self.ui.debug("base, entry %s %s\n" % (basepath, entrypath)) | ||||
frompath, froment = lookup_parts(entrypath) or (None, revnum - 1) | ||||
# need to remove fragment from lookup_parts and replace with copyfrom_path | ||||
if frompath is not None: | ||||
self.ui.debug("munge-o-matic\n") | ||||
self.ui.debug(entrypath + '\n') | ||||
self.ui.debug(entrypath[len(frompath):] + '\n') | ||||
entrypath = froment.copyfrom_path + entrypath[len(frompath):] | ||||
fromrev = froment.copyfrom_rev | ||||
self.ui.debug("Info: %s %s %s %s\n" % (frompath, froment, ent, entrypath)) | ||||
fromkind = svn.ra.check_path(self.ra, entrypath, fromrev) | ||||
if fromkind == svn.core.svn_node_file: # a deleted file | ||||
entries.append(self.recode(entry)) | ||||
elif fromkind == svn.core.svn_node_dir: | ||||
# print "Deleted/moved non-file:", revnum, path, ent | ||||
# children = self._find_children(path, revnum - 1) | ||||
# print "find children %s@%d from %d action %s" % (path, revnum, ent.copyfrom_rev, ent.action) | ||||
# Sometimes this is tricky. For example: in | ||||
# The Subversion Repository revision 6940 a dir | ||||
# was copied and one of its files was deleted | ||||
# from the new location in the same commit. This | ||||
# code can't deal with that yet. | ||||
if ent.action == 'C': | ||||
children = self._find_children(path, fromrev) | ||||
else: | ||||
oroot = entrypath.strip('/') | ||||
nroot = path.strip('/') | ||||
children = self._find_children(oroot, fromrev) | ||||
children = [s.replace(oroot,nroot) for s in children] | ||||
# Mark all [files, not directories] as deleted. | ||||
for child in children: | ||||
# Can we move a child directory and its | ||||
# parent in the same commit? (probably can). Could | ||||
# cause problems if instead of revnum -1, | ||||
# we have to look in (copyfrom_path, revnum - 1) | ||||
entrypath = get_entry_from_path("/" + child, module=old_module) | ||||
if entrypath: | ||||
entry = self.recode(entrypath.decode(self.encoding)) | ||||
if entry in copies: | ||||
# deleted file within a copy | ||||
del copies[entry] | ||||
else: | ||||
entries.append(entry) | ||||
else: | ||||
self.ui.debug('unknown path in revision %d: %s\n' % \ | ||||
(revnum, path)) | ||||
elif kind == svn.core.svn_node_dir: | ||||
# Should probably synthesize normal file entries | ||||
# and handle as above to clean up copy/rename handling. | ||||
# If the directory just had a prop change, | ||||
# then we shouldn't need to look for its children. | ||||
Patrick Mezard
|
r5870 | if ent.action == 'M': | ||
continue | ||||
Brendan Cully
|
r5120 | # Also this could create duplicate entries. Not sure | ||
# whether this will matter. Maybe should make entries a set. | ||||
# print "Changed directory", revnum, path, ent.action, ent.copyfrom_path, ent.copyfrom_rev | ||||
# This will fail if a directory was copied | ||||
# from another branch and then some of its files | ||||
# were deleted in the same transaction. | ||||
children = self._find_children(path, revnum) | ||||
children.sort() | ||||
for child in children: | ||||
# Can we move a child directory and its | ||||
# parent in the same commit? (probably can). Could | ||||
# cause problems if instead of revnum -1, | ||||
# we have to look in (copyfrom_path, revnum - 1) | ||||
entrypath = get_entry_from_path("/" + child, module=self.module) | ||||
# print child, self.module, entrypath | ||||
if entrypath: | ||||
# Need to filter out directories here... | ||||
kind = svn.ra.check_path(self.ra, entrypath, revnum) | ||||
if kind != svn.core.svn_node_dir: | ||||
entries.append(self.recode(entrypath)) | ||||
# Copies here (must copy all from source) | ||||
# Probably not a real problem for us if | ||||
# source does not exist | ||||
# Can do this with the copy command "hg copy" | ||||
# if ent.copyfrom_path: | ||||
# copyfrom_entry = get_entry_from_path(ent.copyfrom_path.decode(self.encoding), | ||||
# module=self.module) | ||||
# copyto_entry = entrypath | ||||
# | ||||
# print "copy directory", copyfrom_entry, 'to', copyto_entry | ||||
# | ||||
# copies.append((copyfrom_entry, copyto_entry)) | ||||
if ent.copyfrom_path: | ||||
copyfrom_path = ent.copyfrom_path.decode(self.encoding) | ||||
copyfrom_entry = get_entry_from_path(copyfrom_path, module=self.module) | ||||
if copyfrom_entry: | ||||
copyfrom[path] = ent | ||||
self.ui.debug("mark %s came from %s\n" % (path, copyfrom[path])) | ||||
# Good, /probably/ a regular copy. Really should check | ||||
# to see whether the parent revision actually contains | ||||
# the directory in question. | ||||
children = self._find_children(self.recode(copyfrom_path), ent.copyfrom_rev) | ||||
children.sort() | ||||
for child in children: | ||||
entrypath = get_entry_from_path("/" + child, module=self.module) | ||||
if entrypath: | ||||
entry = entrypath.decode(self.encoding) | ||||
# print "COPY COPY From", copyfrom_entry, entry | ||||
copyto_path = path + entry[len(copyfrom_entry):] | ||||
copyto_entry = get_entry_from_path(copyto_path, module=self.module) | ||||
# print "COPY", entry, "COPY To", copyto_entry | ||||
copies[self.recode(copyto_entry)] = self.recode(entry) | ||||
# copy from quux splort/quuxfile | ||||
return (entries, copies) | ||||
def _fetch_revisions(self, from_revnum = 0, to_revnum = 347): | ||||
Bryan O'Sullivan
|
r4940 | self.child_cset = None | ||
Bryan O'Sullivan
|
r4946 | def parselogentry(orig_paths, revnum, author, date, message): | ||
self.ui.debug("parsing revision %d (%d changes)\n" % | ||||
(revnum, len(orig_paths))) | ||||
Bryan O'Sullivan
|
r4940 | |||
Daniel Holth
|
r4765 | if revnum in self.modulemap: | ||
new_module = self.modulemap[revnum] | ||||
if new_module != self.module: | ||||
self.module = new_module | ||||
self.reparent(self.module) | ||||
Brendan Cully
|
r4810 | rev = self.revid(revnum) | ||
Brendan Cully
|
r4837 | # branch log might return entries for a parent we already have | ||
Brendan Cully
|
r4839 | if (rev in self.commits or | ||
(revnum < self.lastrevs.get(self.module, 0))): | ||||
Brendan Cully
|
r4837 | return | ||
Brendan Cully
|
r5120 | parents = [] | ||
Brendan Cully
|
r5119 | # check whether this revision is the start of a branch | ||
Brendan Cully
|
r5250 | if self.module in orig_paths: | ||
ent = orig_paths[self.module] | ||||
Brendan Cully
|
r5119 | if ent.copyfrom_path: | ||
# ent.copyfrom_rev may not be the actual last revision | ||||
prev = self.latest(ent.copyfrom_path, ent.copyfrom_rev) | ||||
self.modulemap[prev] = ent.copyfrom_path | ||||
parents = [self.revid(prev, ent.copyfrom_path)] | ||||
self.ui.note('found parent of branch %s at %d: %s\n' % \ | ||||
(self.module, prev, ent.copyfrom_path)) | ||||
else: | ||||
self.ui.debug("No copyfrom path, don't know what to do.\n") | ||||
Brendan Cully
|
r5120 | self.modulemap[revnum] = self.module # track backwards in time | ||
Brendan Cully
|
r5250 | orig_paths = orig_paths.items() | ||
orig_paths.sort() | ||||
Brendan Cully
|
r5120 | paths = [] | ||
# filter out unrelated paths | ||||
Bryan O'Sullivan
|
r4940 | for path, ent in orig_paths: | ||
Brendan Cully
|
r5120 | if not path.startswith(self.module): | ||
Brendan Cully
|
r4788 | self.ui.debug("boring@%s: %s\n" % (revnum, path)) | ||
continue | ||||
Brendan Cully
|
r5120 | paths.append((path, ent)) | ||
Daniel Holth
|
r4765 | |||
Brendan Cully
|
r5121 | self.paths[rev] = (paths, parents) | ||
Daniel Holth
|
r4765 | |||
Brendan Cully
|
r4788 | # Example SVN datetime. Includes microseconds. | ||
# ISO-8601 conformant | ||||
# '2007-01-04T17:35:00.902377Z' | ||||
David J. Mellor
|
r5617 | date = util.parsedate(date[:19] + " UTC", ["%Y-%m-%dT%H:%M:%S"]) | ||
Daniel Holth
|
r4765 | |||
Brendan Cully
|
r4788 | log = message and self.recode(message) | ||
author = author and self.recode(author) or '' | ||||
Brendan Cully
|
r5120 | try: | ||
branch = self.module.split("/")[-1] | ||||
if branch == 'trunk': | ||||
branch = '' | ||||
except IndexError: | ||||
branch = None | ||||
Daniel Holth
|
r4765 | |||
Brendan Cully
|
r4788 | cset = commit(author=author, | ||
Thomas Arendsen Hein
|
r4957 | date=util.datestr(date), | ||
desc=log, | ||||
Brendan Cully
|
r4795 | parents=parents, | ||
Brendan Cully
|
r4873 | branch=branch, | ||
rev=rev.encode('utf-8')) | ||||
Brendan Cully
|
r4788 | |||
Brendan Cully
|
r4796 | self.commits[rev] = cset | ||
if self.child_cset and not self.child_cset.parents: | ||||
Brendan Cully
|
r4788 | self.child_cset.parents = [rev] | ||
self.child_cset = cset | ||||
Brendan Cully
|
r4796 | |||
Bryan O'Sullivan
|
r4940 | self.ui.note('fetching revision log for "%s" from %d to %d\n' % | ||
Brendan Cully
|
r4797 | (self.module, from_revnum, to_revnum)) | ||
Daniel Holth
|
r4765 | |||
try: | ||||
Bryan O'Sullivan
|
r4946 | for entry in self.get_log([self.module], from_revnum, to_revnum): | ||
orig_paths, revnum, author, date, message = entry | ||||
if self.is_blacklisted(revnum): | ||||
self.ui.note('skipping blacklisted revision %d\n' % revnum) | ||||
continue | ||||
if orig_paths is None: | ||||
self.ui.debug('revision %d has no entries\n' % revnum) | ||||
continue | ||||
parselogentry(orig_paths, revnum, author, date, message) | ||||
Thomas Arendsen Hein
|
r5140 | except SubversionException, (inst, num): | ||
Daniel Holth
|
r4765 | if num == svn.core.SVN_ERR_FS_NO_SUCH_REVISION: | ||
Thomas Arendsen Hein
|
r4957 | raise NoSuchRevision(branch=self, | ||
Daniel Holth
|
r4765 | revision="Revision number %d" % to_revnum) | ||
raise | ||||
def _getfile(self, file, rev): | ||||
io = StringIO() | ||||
# TODO: ra.get_file transmits the whole file instead of diffs. | ||||
mode = '' | ||||
try: | ||||
Brendan Cully
|
r4774 | revnum = self.revnum(rev) | ||
Daniel Holth
|
r4765 | if self.module != self.modulemap[revnum]: | ||
self.module = self.modulemap[revnum] | ||||
self.reparent(self.module) | ||||
info = svn.ra.get_file(self.ra, file, revnum, io) | ||||
if isinstance(info, list): | ||||
info = info[-1] | ||||
mode = ("svn:executable" in info) and 'x' or '' | ||||
mode = ("svn:special" in info) and 'l' or mode | ||||
except SubversionException, e: | ||||
notfound = (svn.core.SVN_ERR_FS_NOT_FOUND, | ||||
svn.core.SVN_ERR_RA_DAV_PATH_NOT_FOUND) | ||||
if e.apr_err in notfound: # File not found | ||||
raise IOError() | ||||
raise | ||||
data = io.getvalue() | ||||
if mode == 'l': | ||||
link_prefix = "link " | ||||
if data.startswith(link_prefix): | ||||
data = data[len(link_prefix):] | ||||
return data, mode | ||||
def _find_children(self, path, revnum): | ||||
Brendan Cully
|
r5114 | path = path.strip('/') | ||
Daniel Holth
|
r4765 | pool = Pool() | ||
Brendan Cully
|
r5114 | rpath = '/'.join([self.base, path]).strip('/') | ||
Brendan Cully
|
r5117 | return ['%s/%s' % (path, x) for x in svn.client.ls(rpath, optrev(revnum), True, self.ctx, pool).keys()] | ||
Bryan O'Sullivan
|
r5513 | |||
pre_revprop_change = '''#!/bin/sh | ||||
REPOS="$1" | ||||
REV="$2" | ||||
USER="$3" | ||||
PROPNAME="$4" | ||||
ACTION="$5" | ||||
if [ "$ACTION" = "M" -a "$PROPNAME" = "svn:log" ]; then exit 0; fi | ||||
if [ "$ACTION" = "A" -a "$PROPNAME" = "hg:convert-branch" ]; then exit 0; fi | ||||
if [ "$ACTION" = "A" -a "$PROPNAME" = "hg:convert-rev" ]; then exit 0; fi | ||||
echo "Changing prohibited revision property" >&2 | ||||
exit 1 | ||||
''' | ||||
class svn_sink(converter_sink, commandline): | ||||
commit_re = re.compile(r'Committed revision (\d+).', re.M) | ||||
def prerun(self): | ||||
if self.wc: | ||||
os.chdir(self.wc) | ||||
def postrun(self): | ||||
if self.wc: | ||||
os.chdir(self.cwd) | ||||
def join(self, name): | ||||
return os.path.join(self.wc, '.svn', name) | ||||
Thomas Arendsen Hein
|
r5760 | |||
Bryan O'Sullivan
|
r5513 | def revmapfile(self): | ||
return self.join('hg-shamap') | ||||
def authorfile(self): | ||||
return self.join('hg-authormap') | ||||
def __init__(self, ui, path): | ||||
converter_sink.__init__(self, ui, path) | ||||
commandline.__init__(self, ui, 'svn') | ||||
self.delete = [] | ||||
Maxim Dounin
|
r5698 | self.setexec = [] | ||
self.delexec = [] | ||||
self.copies = [] | ||||
Bryan O'Sullivan
|
r5513 | self.wc = None | ||
self.cwd = os.getcwd() | ||||
path = os.path.realpath(path) | ||||
created = False | ||||
if os.path.isfile(os.path.join(path, '.svn', 'entries')): | ||||
self.wc = path | ||||
self.run0('update') | ||||
else: | ||||
Patrick Mezard
|
r5535 | wcpath = os.path.join(os.getcwd(), os.path.basename(path) + '-wc') | ||
Bryan O'Sullivan
|
r5513 | if os.path.isdir(os.path.dirname(path)): | ||
if not os.path.exists(os.path.join(path, 'db', 'fs-type')): | ||||
ui.status(_('initializing svn repo %r\n') % | ||||
os.path.basename(path)) | ||||
commandline(ui, 'svnadmin').run0('create', path) | ||||
created = path | ||||
Shun-ichi GOTO
|
r5842 | path = util.normpath(path) | ||
Patrick Mezard
|
r5535 | if not path.startswith('/'): | ||
path = '/' + path | ||||
Bryan O'Sullivan
|
r5513 | path = 'file://' + path | ||
Thomas Arendsen Hein
|
r5760 | |||
Bryan O'Sullivan
|
r5513 | ui.status(_('initializing svn wc %r\n') % os.path.basename(wcpath)) | ||
self.run0('checkout', path, wcpath) | ||||
self.wc = wcpath | ||||
self.opener = util.opener(self.wc) | ||||
self.wopener = util.opener(self.wc) | ||||
self.childmap = mapfile(ui, self.join('hg-childmap')) | ||||
Patrick Mezard
|
r5536 | self.is_exec = util.checkexec(self.wc) and util.is_exec or None | ||
Bryan O'Sullivan
|
r5513 | |||
if created: | ||||
hook = os.path.join(created, 'hooks', 'pre-revprop-change') | ||||
fp = open(hook, 'w') | ||||
fp.write(pre_revprop_change) | ||||
fp.close() | ||||
Matt Mackall
|
r5705 | util.set_flags(hook, "x") | ||
Bryan O'Sullivan
|
r5513 | |||
Bryan O'Sullivan
|
r5554 | xport = transport.SvnRaTransport(url=geturl(path)) | ||
self.uuid = svn.ra.get_uuid(xport.ra) | ||||
Bryan O'Sullivan
|
r5513 | def wjoin(self, *names): | ||
return os.path.join(self.wc, *names) | ||||
def putfile(self, filename, flags, data): | ||||
if 'l' in flags: | ||||
self.wopener.symlink(data, filename) | ||||
else: | ||||
try: | ||||
if os.path.islink(self.wjoin(filename)): | ||||
os.unlink(filename) | ||||
except OSError: | ||||
pass | ||||
self.wopener(filename, 'w').write(data) | ||||
Patrick Mezard
|
r5536 | |||
if self.is_exec: | ||||
was_exec = self.is_exec(self.wjoin(filename)) | ||||
else: | ||||
# On filesystems not supporting execute-bit, there is no way | ||||
# to know if it is set but asking subversion. Setting it | ||||
# systematically is just as expensive and much simpler. | ||||
was_exec = 'x' not in flags | ||||
Matt Mackall
|
r5705 | util.set_flags(self.wjoin(filename), flags) | ||
Bryan O'Sullivan
|
r5513 | if was_exec: | ||
if 'x' not in flags: | ||||
Maxim Dounin
|
r5698 | self.delexec.append(filename) | ||
Bryan O'Sullivan
|
r5513 | else: | ||
if 'x' in flags: | ||||
Maxim Dounin
|
r5698 | self.setexec.append(filename) | ||
Bryan O'Sullivan
|
r5513 | def delfile(self, name): | ||
self.delete.append(name) | ||||
def copyfile(self, source, dest): | ||||
Maxim Dounin
|
r5698 | self.copies.append([source, dest]) | ||
def _copyfile(self, source, dest): | ||||
Bryan O'Sullivan
|
r5513 | # SVN's copy command pukes if the destination file exists, but | ||
# our copyfile method expects to record a copy that has | ||||
# already occurred. Cross the semantic gap. | ||||
wdest = self.wjoin(dest) | ||||
exists = os.path.exists(wdest) | ||||
if exists: | ||||
fd, tempname = tempfile.mkstemp( | ||||
prefix='hg-copy-', dir=os.path.dirname(wdest)) | ||||
os.close(fd) | ||||
os.unlink(tempname) | ||||
os.rename(wdest, tempname) | ||||
try: | ||||
self.run0('copy', source, dest) | ||||
finally: | ||||
if exists: | ||||
try: | ||||
os.unlink(wdest) | ||||
except OSError: | ||||
pass | ||||
os.rename(tempname, wdest) | ||||
def dirs_of(self, files): | ||||
dirs = set() | ||||
for f in files: | ||||
if os.path.isdir(self.wjoin(f)): | ||||
dirs.add(f) | ||||
for i in strutil.rfindall(f, '/'): | ||||
dirs.add(f[:i]) | ||||
return dirs | ||||
Maxim Dounin
|
r5698 | def add_dirs(self, files): | ||
Bryan O'Sullivan
|
r5513 | add_dirs = [d for d in self.dirs_of(files) | ||
if not os.path.exists(self.wjoin(d, '.svn', 'entries'))] | ||||
if add_dirs: | ||||
Patrick Mezard
|
r5537 | add_dirs.sort() | ||
Maxim Dounin
|
r5832 | self.xargs(add_dirs, 'add', non_recursive=True, quiet=True) | ||
Maxim Dounin
|
r5698 | return add_dirs | ||
def add_files(self, files): | ||||
Bryan O'Sullivan
|
r5513 | if files: | ||
Maxim Dounin
|
r5832 | self.xargs(files, 'add', quiet=True) | ||
Maxim Dounin
|
r5698 | return files | ||
Thomas Arendsen Hein
|
r5760 | |||
Bryan O'Sullivan
|
r5513 | def tidy_dirs(self, names): | ||
dirs = list(self.dirs_of(names)) | ||||
dirs.sort(reverse=True) | ||||
deleted = [] | ||||
for d in dirs: | ||||
wd = self.wjoin(d) | ||||
if os.listdir(wd) == '.svn': | ||||
self.run0('delete', d) | ||||
deleted.append(d) | ||||
return deleted | ||||
def addchild(self, parent, child): | ||||
self.childmap[parent] = child | ||||
Bryan O'Sullivan
|
r5554 | def revid(self, rev): | ||
return u"svn:%s@%s" % (self.uuid, rev) | ||||
Maxim Dounin
|
r5698 | |||
Bryan O'Sullivan
|
r5513 | def putcommit(self, files, parents, commit): | ||
for parent in parents: | ||||
try: | ||||
Bryan O'Sullivan
|
r5554 | return self.revid(self.childmap[parent]) | ||
Bryan O'Sullivan
|
r5513 | except KeyError: | ||
pass | ||||
entries = set(self.delete) | ||||
Maxim Dounin
|
r5698 | files = util.frozenset(files) | ||
entries.update(self.add_dirs(files.difference(entries))) | ||||
if self.copies: | ||||
for s, d in self.copies: | ||||
self._copyfile(s, d) | ||||
self.copies = [] | ||||
Bryan O'Sullivan
|
r5513 | if self.delete: | ||
Maxim Dounin
|
r5832 | self.xargs(self.delete, 'delete') | ||
Bryan O'Sullivan
|
r5513 | self.delete = [] | ||
entries.update(self.add_files(files.difference(entries))) | ||||
entries.update(self.tidy_dirs(entries)) | ||||
Maxim Dounin
|
r5698 | if self.delexec: | ||
Maxim Dounin
|
r5832 | self.xargs(self.delexec, 'propdel', 'svn:executable') | ||
Maxim Dounin
|
r5698 | self.delexec = [] | ||
if self.setexec: | ||||
Maxim Dounin
|
r5832 | self.xargs(self.setexec, 'propset', 'svn:executable', '*') | ||
Maxim Dounin
|
r5698 | self.setexec = [] | ||
Bryan O'Sullivan
|
r5513 | fd, messagefile = tempfile.mkstemp(prefix='hg-convert-') | ||
fp = os.fdopen(fd, 'w') | ||||
fp.write(commit.desc) | ||||
fp.close() | ||||
try: | ||||
output = self.run0('commit', | ||||
username=util.shortuser(commit.author), | ||||
file=messagefile, | ||||
Shun-ichi GOTO
|
r5790 | encoding='utf-8') | ||
Bryan O'Sullivan
|
r5513 | try: | ||
rev = self.commit_re.search(output).group(1) | ||||
except AttributeError: | ||||
self.ui.warn(_('unexpected svn output:\n')) | ||||
self.ui.warn(output) | ||||
raise util.Abort(_('unable to cope with svn output')) | ||||
if commit.rev: | ||||
self.run('propset', 'hg:convert-rev', commit.rev, | ||||
revprop=True, revision=rev) | ||||
if commit.branch and commit.branch != 'default': | ||||
self.run('propset', 'hg:convert-branch', commit.branch, | ||||
revprop=True, revision=rev) | ||||
for parent in parents: | ||||
self.addchild(parent, rev) | ||||
Bryan O'Sullivan
|
r5554 | return self.revid(rev) | ||
Bryan O'Sullivan
|
r5513 | finally: | ||
os.unlink(messagefile) | ||||
def puttags(self, tags): | ||||
self.ui.warn(_('XXX TAGS NOT IMPLEMENTED YET\n')) | ||||